<template>
  <div class="currency-detail">
    <div class="currency-detail-content" ref="currencyDetail">
      <div ref="graph">
        <div class="title">{{ currency.name }} ({{ this.currency.code }})</div>
        <ve-line
          :data="data"
          :grid="grid"
          :legend-visible="false"
          :tooltip="tooltip"
          :yAxis="yAxis"
          :xAxis="xAxis"
          :colors="['#004BC8']"
          :data-zoom="dataZoom"
          :height="'300px'"
        />
        <div class="period">
          {{ dictionaryRu.currency_detail.period.title }}
          <div
            class="period-item"
            :class="{active: activePeriod === PERIOD.WEEK}"
            @click="setActivePeriod(PERIOD.WEEK)"
          >
            {{dictionaryRu.currency_detail.period.week }}
          </div>
          <div
            class="period-item"
            :class="{active: activePeriod === PERIOD.MONTH}"
            @click="setActivePeriod(PERIOD.MONTH)"
          >
            {{ dictionaryRu.currency_detail.period.month }}
          </div>
          <div
            class="period-item"
            :class="{active: activePeriod === PERIOD.QUARTER}"
            @click="setActivePeriod(PERIOD.QUARTER)"
          >
            {{ dictionaryRu.currency_detail.period.quarter }}
          </div>
          <div
            class="period-item"
            :class="{active: activePeriod === PERIOD.YEAR}"
            @click="setActivePeriod(PERIOD.YEAR)"
          >
            {{ dictionaryRu.currency_detail.period.year }}
          </div>
        </div>
      </div>
      <div class="dynamics">
        <table ref="dynamicsHeader">
          <tr>
            <th>{{ dictionaryRu.currency_detail.dynamics.columns.date }}</th>
            <th>{{ dictionaryRu.currency_detail.dynamics.columns.course }}</th>
            <th>{{ dictionaryRu.currency_detail.dynamics.columns.dynamics }}</th>
          </tr>
        </table>
        <table>
          <tr v-for="row in descCurrencyData" :row="row" :key="row.uuid" :class="{now: compareNow(row.date)}">
            <td>{{ getConvertDate(row.date) }}</td>
            <td>{{row.currency_rate}}</td>
            <td><span :class="'dynamics-' + getColor(row.currency_rate_dynamics)">{{row.currency_rate_dynamics}}</span></td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import 'moment/locale/ru'
import 'moment/locale/en-gb'
import api                   from '@/api';
import moment                from 'moment';
import { VeLine }            from 'v-charts'
import cloneDeep             from 'clone-deep'
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__common__currencies'

const PERIOD = {
  WEEK: 'week',
  MONTH: 'month',
  QUARTER: 'quarter',
  YEAR: 'year'
}

export default {
  name: 'currency-detail',
  components: {
    VeLine
  },
  props: {
    currency: {
      type: Object,
      default: null
    },
    activeCurrency: {
      type: String,
      default: ''
    },
    date: {
      type: [String, Object, Date],
      default: () => new Date()
    }
  },
  computed: {
    descCurrencyData() {
      let compare = (a, b) => {
        return moment(b.date) - moment(a.date)
      }
      return cloneDeep(this.data.rows).sort(compare)
    },
    currencyCode () {
      return this.currency && this.currency.code
    }
  },
  data () {
    return {
      PERIOD,
      activePeriod: PERIOD.WEEK,
      grid: {
        top: 0,
        left: 0,
        width: '100%',
        bottom: 37,
        show: true,
        borderColor: '#CFD3E1'
      },
      data: {
        columns: ['date', 'currency_rate'],
        rows: []
      },
      tooltip: {
        backgroundColor: 'white',
        borderWidth: 0,
        padding: 0,
        trigger: 'axis',
        color: "#004BC8",
        axisPointer: {
          animation: true
        },
        formatter: params => {
          let value = params[0]
          return '<div class="tooltip">' +
                  '<span class="value">' + value.data[1] + '</span> '
                  + this.currency.code + ' ' + this.dictionaryRu.currency_detail.pretext + ' ' + this.activeCurrency + '</br>' +
                  '<span class="date">' + moment(value.data[0]).format('DD.MM.YYYY, ddd') + '</span>' +
                  '</div>'
        }
      },
      dataZoom: [
        {
          type: 'slider',
          start: 0,
          end: 100,
          backgroundColor: 'white',
          fillerColor: 'rgba(16, 207, 150, 0.2)',
          left: -3,
          width: '100%',
          height: 40,
          handleIcon: 'image://data:image/svg+xml;base64,PHN2ZyB3aWR0aD0iMzkiIGhlaWdodD0iMzkiIHZpZXdCb3g9IjAgMCAzOSAzOSIgZmlsbD0icmVkIiB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciPgo8bGluZSB4MT0iMTkuNSIgeTE9Ii0yLjE4NTU3ZS0wOCIgeDI9IjE5LjUiIHkyPSIzOSIgc3Ryb2tlPSIjQzRDNEM0Ii8+CjxyZWN0IHg9IjE1LjUiIHk9IjkuNSIgd2lkdGg9IjgiIGhlaWdodD0iMTkiIGZpbGw9IndoaXRlIiBzdHJva2U9IiNDNEM0QzQiLz4KPGxpbmUgeDE9IjE4LjUiIHkxPSIxMyIgeDI9IjE4LjUiIHkyPSIyNSIgc3Ryb2tlPSIjQzRDNEM0Ii8+CjxsaW5lIHgxPSIyMC41IiB5MT0iMTMiIHgyPSIyMC41IiB5Mj0iMjUiIHN0cm9rZT0iI0M0QzRDNCIvPgo8L3N2Zz4K',
          dataBackground: {
            areaStyle: {
              color: '#9DA0AC',
              opacity: 1
            }
          },
          labelFormatter: function (value, valueStr) {
            return moment(valueStr).format('DD.MM.YYYY')
          }
        }
      ],
      yAxis: [{
        min: 'dataMin',
        axisLabel: {
          inside: true,
          verticalAlign: 'top',
          color: '#757884',
          padding: [5, 0, 0, 0]
        },
        splitLine: {
          lineStyle: {
            color: '#CFD3E1',
          }
        },
        axisLine: {
          show: true,
          lineStyle: {
            color: '#CFD3E1',
          }
        }
      }],
      xAxis: [{
        show: true,
        position: 'top',
        type: 'category',
        axisLabel: {
          color: '#9DA0AC',
          formatter: function (value) {
            return moment(value).format('DD.MM.YYYY')
          }
        },
      }],
      dynamicsHeight: 0,
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  mounted () {
    this.getCurrencyDetail();
    this.dynamicsHeight = this.$refs.currencyDetail.clientHeight - this.$refs.graph.clientHeight - this.$refs.dynamicsHeader.clientHeight
  },
  methods: {
    async getCurrencyDetail () {
      try {
        if (this.currencyCode) {
          let datesRange = this.getDatesRange()
          let _data = await api.general.getCurrenciesDynamics({
            currency: this.currencyCode,
            startDate: datesRange.startDate,
            endDate: datesRange.endDate,
            target: this.activeCurrency
          });
          this.data.rows = _data.data
        }
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }

    },
    compareNow(date) {
      let _date = moment(date).format('DD.MM.YYYY')
      let _now = moment(new Date()).format('DD.MM.YYYY')
      return _date === _now
    },
    getColor(rate) {
      return rate > 0 ? 'green' : 'red'
    },
    getConvertDate(date) {
      return this.compareNow(date) ? this.dictionaryRu.currency_detail.dynamics.now : moment(date).format('DD.MM.YYYY')
    },
    getDatesRange() {
      let _startDate
      let _endDate
      switch (this.activePeriod) {
        case PERIOD.WEEK:
          _startDate = moment(this.date).subtract(1, 'w').format('YYYY-MM-DD')
          break
        case PERIOD.MONTH:
          _startDate = moment(this.date).subtract(1, 'M').format('YYYY-MM-DD')
          break
        case PERIOD.QUARTER:
          _startDate = moment(this.date).subtract(1, 'Q').format('YYYY-MM-DD')
          break
        case PERIOD.YEAR:
          _startDate = moment(this.date).subtract(1, 'y').format('YYYY-MM-DD')
          break
      }
      _endDate = moment(this.date).format('YYYY-MM-DD')
      return {
        startDate: _startDate,
        endDate: _endDate
      }
    },
    setActivePeriod(period) {
      if(this.activePeriod !== period) {
        this.activePeriod = period
        this.getCurrencyDetail()
      }
    }
  },
  watch: {
    currency: {
      deep: true,
      handler: function () {
        this.getCurrencyDetail()
      }
    },
    date () {
      this.getCurrencyDetail()
    },
    activeCurrency () {
      this.getCurrencyDetail()
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/variables";
  @import "~common-components/src/static/css/mixins";
  .currency-detail {
    padding: 40px;
  }
  .currency-detail, .currency-detail-content {
    height: 100%;
  }
  .title {
    @include font-mixin(28px, 36px, 0.8px, 400, $color-text-base);
    margin-bottom: 20px;
  }
  .period {
    padding: 10px 0 20px;
    @include font-mixin(12px, 12px, 0.4px, 400, $color-text-base);
  }
  .period-item {
    display: inline-block;
    color: $color-blue-navy-blue;
    text-decoration: underline;
    padding: 8px 12px;
    cursor: pointer;
    border-radius: 19px;
    &:hover, &.active {
      text-decoration: none;
    }
    &.active {
      background: $lavender;
    }
  }
  table {
    th {
      @include font-mixin(11px, 12px, 0.4px, 400, $color-grey-label);
      text-align: left;
      text-transform: uppercase;
      font-variant: small-caps;
    }
    td {
      @include font-mixin(14px, 20px, 0.2px, 400, $color-grey-label);
    }
    th, td {
      padding: 10px 15px;
      width: 100px;
      &:first-child {
        padding-left: 0;
      }
      &:last-child {
        padding-right: 0;
      }
    }
    .now {
      td {
        font-weight: bold;
      }
    }
  }

</style>
<style lang="scss">
 .ve-line {
    .tooltip {
      padding: 10px 12px 10px 12px;
      border: 1px solid $color-blue-navy-blue;
      color: $shale-gray;
      font-size: 10px;
      .value {
        color:  $color-text-base;
        font-size: 16px;
      }
      .date {
        color: $color-grey-span;
      }
    }
  }
</style>
